| Flutter Impeller |

Public Member Functions | Static Public Member Functions | List of all members
impeller::DlImageImpeller Class Referencefinal

`#include <dl_image_impeller.h>`

Inheritance diagram for impeller::DlImageImpeller:

## Public Member Functions
| ~DlImageImpeller () override
sk_sp< SkImage > | skia_image () const override
std::shared_ptr< impeller::Texture > | impeller_texture () const override
bool | isOpaque () const override
bool | isTextureBacked () const override
bool | isUIThreadSafe () const override
SkISize | dimensions () const override
flutter::DlISize | GetSize () const override
size_t | GetApproximateByteSize () const override
OwningContext | owning_context () const override

## Static Public Member Functions
static sk_sp< DlImageImpeller > | Make (std::shared_ptr< Texture > texture, OwningContext owning_context=OwningContext::kIO)
static sk_sp< DlImageImpeller > | MakeFromYUVTextures (AiksContext *aiks_context, std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)

## Detailed Description

Definition at line 15 of file dl_image_impeller.h.

## Constructor & Destructor Documentation

## ◆ ~DlImageImpeller()

impeller::DlImageImpeller::~DlImageImpeller | ( |  | ) |
| override default

## Member Function Documentation

## ◆ dimensions()

SkISize impeller::DlImageImpeller::dimensions | ( |  | ) | const
| override

Definition at line 107 of file dl_image_impeller.cc.

107 {
108 const auto size = texture_ ? texture_->GetSize() : ISize{};
109 return SkISize::Make(size.width, size.height);
110 }
impeller::ISize
ISize64 ISize
Definition: size.h:162

## ◆ GetApproximateByteSize()

size_t impeller::DlImageImpeller::GetApproximateByteSize | ( |  | ) | const
| override

Definition at line 120 of file dl_image_impeller.cc.

120 {
121 auto size = sizeof(*this);
122 if (texture_) {
123 size += texture_->GetTextureDescriptor().GetByteSizeOfBaseMipLevel();
124 }
125 return size;
126 }

## ◆ GetSize()

flutter::DlISize impeller::DlImageImpeller::GetSize | ( |  | ) | const
| override

Definition at line 113 of file dl_image_impeller.cc.

113 {
114 // texture |GetSize()| returns a 64-bit size, but we need a 32-bit size,
115 // so we need to convert to DlISize (the 32-bit variant) either way.
116 return texture_ ? flutter::DlISize(texture_->GetSize()) : flutter::DlISize();
117 }
flutter
Definition: dl_golden_blur_unittests.cc:16

## ◆ impeller_texture()

std::shared_ptr< impeller::Texture > impeller::DlImageImpeller::impeller_texture | ( |  | ) | const
| override

Definition at line 84 of file dl_image_impeller.cc.

84 {
85 return texture_;
86 }

## ◆ isOpaque()

bool impeller::DlImageImpeller::isOpaque | ( |  | ) | const
| override

Definition at line 89 of file dl_image_impeller.cc.

89 {
90 // Impeller doesn't currently implement opaque alpha types.
91 return false;
92 }

## ◆ isTextureBacked()

bool impeller::DlImageImpeller::isTextureBacked | ( |  | ) | const
| override

Definition at line 95 of file dl_image_impeller.cc.

95 {
96 // Impeller textures are always ... textures :/
97 return true;
98 }

## ◆ isUIThreadSafe()

bool impeller::DlImageImpeller::isUIThreadSafe | ( |  | ) | const
| override

Definition at line 101 of file dl_image_impeller.cc.

101 {
102 // Impeller textures are always thread-safe
103 return true;
104 }

## ◆ Make()

sk_sp< DlImageImpeller > impeller::DlImageImpeller::Make | ( | std::shared_ptr< Texture > | texture,
|  | OwningContext | owning_context = `OwningContext::kIO`
| ) |  |
| static

Definition at line 23 of file dl_image_impeller.cc.

24 {
25 if (!texture) {
26 return nullptr;
27 }
28 return sk_sp<DlImageImpeller>(
29 new DlImageImpeller(std::move(texture), owning_context));
30 }
impeller::DlImageImpeller::owning_context
OwningContext owning_context() const override
Definition: dl_image_impeller.h:60

References owning_context().

Referenced by impeller::DlPlayground::CreateDlImageForFixture(), impeller::GoldenPlaygroundTest::CreateDlImageForFixture(), MakeFromYUVTextures(), impeller::interop::Texture::MakeImage(), and impeller::testing::TEST_P().

## ◆ MakeFromYUVTextures()

sk_sp< DlImageImpeller > impeller::DlImageImpeller::MakeFromYUVTextures | ( | AiksContext * | aiks_context,
|  | std::shared_ptr< Texture > | y_texture,
|  | std::shared_ptr< Texture > | uv_texture,
|  | YUVColorSpace | yuv_color_space
| ) |  |
| static

Definition at line 33 of file dl_image_impeller.cc.

37 {
38 if (!aiks_context || !y_texture || !uv_texture) {
39 return nullptr;
40 }
41 auto yuv_to_rgb_filter_contents = FilterContents::MakeYUVToRGBFilter(
42 std::move(y_texture), std::move(uv_texture), yuv_color_space);
43 impeller::Entity entity;
44 entity.SetBlendMode(impeller::BlendMode::kSrc);
45 auto snapshot = yuv_to_rgb_filter_contents->RenderToSnapshot(
46 aiks_context->GetContentContext(), // renderer
47 entity, // entity
48 std::nullopt, // coverage_limit
49 std::nullopt, // sampler_descriptor
50 true, // msaa_enabled
51 /*mip_count=*/1,
52 "MakeYUVToRGBFilter Snapshot"); // label
53 if (!snapshot.has_value()) {
54 return nullptr;
55 }
56 return impeller::DlImageImpeller::Make(snapshot->texture);
57 }
impeller::DlImageImpeller::Make
static sk_sp< DlImageImpeller > Make(std::shared_ptr< Texture > texture, OwningContext owning_context=OwningContext::kIO)
Definition: dl_image_impeller.cc:23
impeller::Entity
Definition: entity.h:20
impeller::Entity::SetBlendMode
void SetBlendMode(BlendMode blend_mode)
Definition: entity.cc:97
impeller::FilterContents::MakeYUVToRGBFilter
static std::shared_ptr< FilterContents > MakeYUVToRGBFilter(std::shared_ptr< Texture > y_texture, std::shared_ptr< Texture > uv_texture, YUVColorSpace yuv_color_space)
Definition: filter_contents.cc:108
impeller::BlendMode::kSrc
@ kSrc

References impeller::AiksContext::GetContentContext(), impeller::kSrc, Make(), impeller::FilterContents::MakeYUVToRGBFilter(), and impeller::Entity::SetBlendMode().

## ◆ owning_context()

OwningContext impeller::DlImageImpeller::owning_context | ( |  | ) | const
| inline override

Definition at line 60 of file dl_image_impeller.h.

60 { return owning_context_; }

Referenced by Make().

## ◆ skia_image()

sk_sp< SkImage > impeller::DlImageImpeller::skia_image | ( |  | ) | const
| override

Definition at line 79 of file dl_image_impeller.cc.

79 {
80 return nullptr;
81 };

The documentation for this class was generated from the following files:

- impeller/display_list/dl_image_impeller.h
- impeller/display_list/dl_image_impeller.cc